diff -Nur linux-2.4.30/drivers/usb/gadget/Config.in linux-2.4.30-linux-mips.org/drivers/usb/gadget/Config.in
--- linux-2.4.30/drivers/usb/gadget/Config.in	2005-01-19 15:10:06.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/usb/gadget/Config.in	2005-05-12 18:01:29.000000000 +0200
@@ -18,6 +18,7 @@
   choice 'USB Peripheral Controller Driver' "\
 	NetChip-2280			CONFIG_USB_GADGET_NET2280 \
 	Toshiba-TC86C001(Goku-S)	CONFIG_USB_GADGET_GOKU \
+	AMD5536-UDC	                CONFIG_USB_GADGET_AMD5536UDC \
 	" NetChip-2280
 
   define_tristate CONFIG_USB_GADGET_CONTROLLER n
@@ -30,9 +31,14 @@
     define_tristate CONFIG_USB_GOKU $CONFIG_USB_GADGET
     define_tristate CONFIG_USB_GADGET_CONTROLLER $CONFIG_USB_GOKU
   fi
+  if [ "$CONFIG_PCI" = "y" -a "$CONFIG_USB_GADGET_AMD5536UDC" = "y" ] ; then
+    define_tristate CONFIG_USB_AMD5536UDC $CONFIG_USB_GADGET
+    define_tristate CONFIG_USB_GADGET_CONTROLLER $CONFIG_USB_AMD5536UDC
+  fi
 
   # or any other controller that supports high speed transfers ...
   define_bool CONFIG_USB_GADGET_DUALSPEED $CONFIG_USB_GADGET_NET2280
+  define_bool CONFIG_USB_GADGET_DUALSPEED $CONFIG_USB_GADGET_AMD5536UDC
 
   if [ "$CONFIG_USB_GADGET_CONTROLLER" = "y" -o "$CONFIG_USB_GADGET_CONTROLLER" = "m" ] ; then
 
@@ -81,4 +87,45 @@
     fi
   fi
 fi
+
+#
+# USB OTG configuration
+#
+  comment ''
+
+if [ "$CONFIG_PCI" = "y" -a "$CONFIG_USB_GADGET_AMD5536UDC" = "y" ] ; then
+ tristate 'Support for USB On-The-Go' CONFIG_USB_OTG_CONTROLLER
+ if [ "$CONFIG_USB_OTG_CONTROLLER" = "y" -o "$CONFIG_USB_OTG_CONTROLLER" = "m" ]; then
+   bool '  AMD 5536 On-The-Go support' CONFIG_USB_AMD5536OTG $CONFIG_USB_OTG_CONTROLLER
+   if [ "$CONFIG_USB_AMD5536OTG" = "y" -o  "$CONFIG_USB_AMD5536OTG" = "m" ]; then
+     comment '    OTG port functionality'
+        comment '      Full On-The-Go support not supported yet'
+     if [ "$CONFIG_USB_OTG" != "y" -a "$CONFIG_USB_OTGMUX_GADGET" != "y" -a "$CONFIG_USB_OTGMUX_IDPIN" != "y" ]; then
+       bool '      Host only' CONFIG_USB_OTGMUX_HOST
+       if [ "$CONFIG_USB_OTGMUX_HOST" = "y" ]; then
+         define_bool CONFIG_USB_OTGMUX_IDPIN n
+         define_bool CONFIG_USB_OTGMUX_GADGET n
+         define_bool CONFIG_USB_OTG n
+       fi
+     fi
+     if [ "$CONFIG_USB_OTG" != "y" -a "$CONFIG_USB_OTGMUX_HOST" != "y" -a "$CONFIG_USB_OTGMUX_IDPIN" != "y" ]; then
+       bool '      Gadget only' CONFIG_USB_OTGMUX_GADGET
+       if [ "$CONFIG_USB_OTGMUX_GADGET" = "y" ]; then
+         define_bool CONFIG_USB_OTGMUX_IDPIN n
+         define_bool CONFIG_USB_OTGMUX_HOST n
+         define_bool CONFIG_USB_OTG n
+       fi
+     fi
+     if [ "$CONFIG_USB_OTG" != "y" -a "$CONFIG_USB_OTGMUX_HOST" != "y" -a "$CONFIG_USB_OTGMUX_GADGET" != "y" ]; then
+       bool '      ID pin dependend' CONFIG_USB_OTGMUX_IDPIN
+       if [ "$CONFIG_USB_OTGMUX_IDPIN" = "y" ]; then
+         define_bool CONFIG_USB_OTGMUX_HOST n
+         define_bool CONFIG_USB_OTGMUX_GADGET n
+         define_bool CONFIG_USB_OTG n
+       fi
+     fi
+   fi
+ fi
+fi
+
 endmenu
diff -Nur linux-2.4.30/drivers/usb/gadget/ether.c linux-2.4.30-linux-mips.org/drivers/usb/gadget/ether.c
--- linux-2.4.30/drivers/usb/gadget/ether.c	2005-01-19 15:10:06.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/usb/gadget/ether.c	2005-05-12 18:01:29.000000000 +0200
@@ -162,8 +162,15 @@
 /* Thanks to NetChip Technologies for donating this product ID.
  * It's for devices with only CDC Ethernet configurations.
  */
+#ifdef CONFIG_USB_GADGET_AMD5536UDC
+#define CDC_VENDOR_NUM	0x0438		/* AMD */
+#define CDC_PRODUCT_NUM	0xdc01		/* Linux-USB Ethernet Gadget */
+/* TODO better place for define */
+#define UDC_MAX_BUFLEN 2048
+#else
 #define CDC_VENDOR_NUM	0x0525		/* NetChip */
 #define CDC_PRODUCT_NUM	0xa4a1		/* Linux-USB Ethernet Gadget */
+#endif
 
 /* For hardware that can't talk CDC, we use the same vendor ID that
  * ARM Linux has used for ethernet-over-usb, both with sa1100 and
@@ -260,6 +267,9 @@
 #define DEV_CONFIG_CDC
 #endif
 
+#ifdef CONFIG_USB_GADGET_AMD5536UDC
+#define	DEV_CONFIG_CDC
+#endif
 
 /* For CDC-incapable hardware, choose the simple cdc subset.
  * Anything that talks bulk (without notable bugs) can do this.
@@ -1162,6 +1172,10 @@
 			req = container_of (dev->tx_reqs.next,
 						struct usb_request, list);
 			list_del (&req->list);
+#ifdef CONFIG_USB_GADGET_AMD5536UDC
+                        if (req->buf)
+                                usb_ep_free_buffer (dev->in_ep, req->buf, req->dma, UDC_MAX_BUFLEN);
+#endif
 			usb_ep_free_request (dev->in_ep, req);
 		}
 		dev->in_ep = NULL;
@@ -1172,6 +1186,10 @@
 			req = container_of (dev->rx_reqs.next,
 						struct usb_request, list);
 			list_del (&req->list);
+#ifdef CONFIG_USB_GADGET_AMD5536UDC
+                        if (req->buf)
+                                usb_ep_free_buffer (dev->out_ep, req->buf, req->dma, UDC_MAX_BUFLEN);
+#endif
 			usb_ep_free_request (dev->out_ep, req);
 		}
 		dev->out_ep = NULL;
@@ -1341,7 +1359,7 @@
 		return;
 	}
 	req->buf = usb_ep_alloc_buffer (dev->status_ep, 16,
-				&dev->req->dma, GFP_ATOMIC);
+				&req->dma, GFP_ATOMIC);
 	if (req->buf == 0) {
 		DEBUG (dev, "status buf ENOMEM\n");
 free_req:
@@ -1785,7 +1803,9 @@
 		goto enomem;
 	}
 
+#ifndef CONFIG_USB_GADGET_AMD5536UDC
 	req->buf = skb->data;
+#endif
 	req->length = size;
 	req->complete = rx_complete;
 	req->context = skb;
@@ -1827,6 +1847,16 @@
 			break;
 		}
 
+#ifdef CONFIG_USB_GADGET_AMD5536UDC
+                /* TODO TDB we need to copy here because UDC needs dword aligned buffers */
+                VDEBUG(dev, "memcpy( skb->data %lx,req->buf %lx,req->actual %d)\n",  skb->data,req->buf,req->actual);
+                if (req->actual <= UDC_MAX_BUFLEN) {
+                        memcpy(skb->data, req->buf, req->actual);
+                }
+                else {
+                        ERROR(dev, "memcpy of %d bytes bigger than max %d\n", req->actual, UDC_MAX_BUFLEN);
+                }
+#endif
 		skb->dev = dev->net;
 		skb->protocol = eth_type_trans (skb, dev->net);
 		dev->stats.rx_packets++;
@@ -1895,6 +1925,15 @@
 		req = usb_ep_alloc_request (ep, gfp_flags);
 		if (!req)
 			return list_empty (list) ? -ENOMEM : 0;
+
+
+#ifdef CONFIG_USB_GADGET_AMD5536UDC
+                /* TODO TDB allocate buffer which must be dword aligned for UDC */
+                req->buf = usb_ep_alloc_buffer (ep, UDC_MAX_BUFLEN, 
+                                &req->dma, GFP_ATOMIC);
+#endif
+
+
 		list_add (&req->list, list);
 	}
 	return 0;
@@ -1906,6 +1945,10 @@
 
 		next = req->list.next;
 		list_del (&req->list);
+#ifdef CONFIG_USB_GADGET_AMD5536UDC
+                if (req->buf)
+                        usb_ep_free_buffer (ep, req->buf, req->dma, UDC_MAX_BUFLEN);
+#endif
 		usb_ep_free_request (ep, req);
 
 		if (next == list)
@@ -2039,7 +2082,19 @@
 		length = skb->len;
 	}
 #endif
+#ifdef CONFIG_USB_GADGET_AMD5536UDC
+                /* TODO TDB we need to copy here because UDC needs dword aligned buffers */
+        VDEBUG(dev, "memcpy(req->buf %lx, skb->data %lx, length %d)", req->buf, skb->data, length);
+        if (length <= UDC_MAX_BUFLEN) {
+                memcpy(req->buf, skb->data, length);
+        }
+        else {
+                ERROR(dev, "memcpy of %d bytes bigger than max %d\n", length, UDC_MAX_BUFLEN);
+        }
+        VDEBUG(dev, "past memcpy(req->buf %lx, skb->data %lx, length %d)", req->buf, skb->data, length);
+#else
 	req->buf = skb->data;
+#endif
 	req->context = skb;
 	req->complete = tx_complete;
 
@@ -2345,6 +2400,8 @@
 		device_desc.bcdDevice = __constant_cpu_to_le16 (0x0210);
 	} else if (gadget_is_pxa27x(gadget)) {
 		device_desc.bcdDevice = __constant_cpu_to_le16 (0x0211);
+	} else if (gadget_is_amd5536udc (gadget)) {
+		device_desc.bcdDevice = __constant_cpu_to_le16 (0x0212);
 	} else {
 		/* can't assume CDC works.  don't want to default to
 		 * anything less functional on CDC-capable hardware,
diff -Nur linux-2.4.30/drivers/usb/gadget/file_storage.c linux-2.4.30-linux-mips.org/drivers/usb/gadget/file_storage.c
--- linux-2.4.30/drivers/usb/gadget/file_storage.c	2004-08-08 01:26:05.000000000 +0200
+++ linux-2.4.30-linux-mips.org/drivers/usb/gadget/file_storage.c	2005-05-12 18:01:29.000000000 +0200
@@ -249,9 +249,13 @@
  *
  * DO NOT REUSE THESE IDs with any other driver!!  Ever!!
  * Instead:  allocate your own, using normal USB-IF procedures. */
-#define DRIVER_VENDOR_ID	0x0525	// NetChip
-#define DRIVER_PRODUCT_ID	0xa4a5	// Linux-USB File-backed Storage Gadget
-
+#ifdef CONFIG_USB_GADGET_AMD5536UDC
+#define DRIVER_VENDOR_ID	0x0438		/* AMD */
+#define DRIVER_PRODUCT_ID	0xdc02		/* Linux-USB File-backed Storage Gadget */
+#else
+#define DRIVER_VENDOR_ID	0x0525		/* NetChip */
+#define DRIVER_PRODUCT_ID	0xa4a5		/* Linux-USB File-backed Storage Gadget */
+#endif
 
 /*
  * This driver assumes self-powered hardware and has no way for users to
@@ -1330,6 +1334,7 @@
 		case USB_DT_DEVICE:
 			VDBG(fsg, "get device descriptor\n");
 			value = min(ctrl->wLength, (u16) sizeof device_desc);
+                        device_desc.bMaxPacketSize0 = fsg->ep0->maxpacket;
 			memcpy(req->buf, &device_desc, value);
 			break;
 #ifdef CONFIG_USB_GADGET_DUALSPEED
@@ -1670,8 +1675,11 @@
 			curlun->sense_data = SS_INVALID_FIELD_IN_CDB;
 			return -EINVAL;
 		}
-		if (fsg->cmnd[1] & 0x08)	// FUA
-			curlun->filp->f_flags |= O_SYNC;
+                /* FUA avoids cache -> slow */
+                /* FIXME make sure that device is self powered otherwise
+                 * cached data may be lost on disconnect */
+		/*if (fsg->cmnd[1] & 0x08)	// FUA
+			curlun->filp->f_flags |= O_SYNC;*/
 	}
 	if (lba >= curlun->num_sectors) {
 		curlun->sense_data = SS_LOGICAL_BLOCK_ADDRESS_OUT_OF_RANGE;
@@ -3582,6 +3590,10 @@
 			mod_data.release = __constant_cpu_to_le16(0x0227);
 		else if (gadget_is_omap(fsg->gadget))
 			mod_data.release = __constant_cpu_to_le16(0x0228);
+		else if (gadget_is_amd5536udc(fsg->gadget)) {
+			mod_data.release = __constant_cpu_to_le16(0x0229);
+		        mod_data.can_stall = 0;
+                }
 		else {
 			WARN(fsg, "controller '%s' not recognized\n",
 				fsg->gadget->name);
diff -Nur linux-2.4.30/drivers/usb/gadget/gadget_chips.h linux-2.4.30-linux-mips.org/drivers/usb/gadget/gadget_chips.h
--- linux-2.4.30/drivers/usb/gadget/gadget_chips.h	2005-01-19 15:10:06.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/usb/gadget/gadget_chips.h	2005-05-12 18:01:29.000000000 +0200
@@ -74,6 +74,13 @@
 #define	gadget_is_pxa27x(g)	0
 #endif
 
+#ifdef CONFIG_USB_GADGET_AMD5536UDC
+#define	gadget_is_amd5536udc(g)	!strcmp("amd5536udc", (g)->name)
+#else
+#define	gadget_is_amd5536udc(g)	0
+#endif
+
+#
 // CONFIG_USB_GADGET_AT91RM9200
 // CONFIG_USB_GADGET_SX2
 // CONFIG_USB_GADGET_AU1X00
diff -Nur linux-2.4.30/drivers/usb/gadget/Makefile linux-2.4.30-linux-mips.org/drivers/usb/gadget/Makefile
--- linux-2.4.30/drivers/usb/gadget/Makefile	2004-08-08 01:26:05.000000000 +0200
+++ linux-2.4.30-linux-mips.org/drivers/usb/gadget/Makefile	2005-05-12 18:01:29.000000000 +0200
@@ -10,10 +10,21 @@
 
 obj-$(CONFIG_USB_NET2280)	+= net2280.o
 obj-$(CONFIG_USB_GOKU)		+= goku_udc.o
+obj-$(CONFIG_USB_AMD5536UDC)	+= amd5536udc.o
+
+ifeq ($(CONFIG_USB_AMD5536OTG),y)
+obj-$(CONFIG_USB_OTG_CONTROLLER)	+= amd5536otg.o
+endif
 
 # only one of these may be statically linked ...
 controller-$(CONFIG_USB_NET2280)	+= net2280.o
 controller-$(CONFIG_USB_GOKU)		+= goku_udc.o
+controller-$(CONFIG_USB_AMD5536UDC)	+= amd5536udc.o
+
+# OTG ...
+ifeq ($(CONFIG_USB_AMD5536OTG),y)
+controller-$(CONFIG_USB_OTG_CONTROLLER)	+= amd5536uoc.o
+endif
 
 # ... and only one of these, too; kbuild/kconfig don't help though.
 g_zero-objs			:= zero.o usbstring.o config.o epautoconf.o
@@ -29,6 +40,12 @@
 						epautoconf.o
 obj-$(CONFIG_USB_FILE_STORAGE)	+= g_file_storage.o
 
+# OTG ...
+otg-objs			:= amd5536uoc.o
+ifeq ($(CONFIG_USB_OTG),y)
+otg-objs			+= otg-fsm.o
+endif
+
 export-objs :=			$(controller-y) $(controller-m)
 
 include $(TOPDIR)/Rules.make
@@ -39,3 +56,6 @@
 	$(LD) -r -o $@ $(g_ether-objs)
 g_file_storage.o: $(g_file_storage-objs)
 	$(LD) -r -o $@ $(g_file_storage-objs)
+
+amd5536otg.o: $(otg-objs)
+	$(LD) -r -o $@ $(otg-objs)
diff -Nur linux-2.4.30/drivers/usb/gadget/zero.c linux-2.4.30-linux-mips.org/drivers/usb/gadget/zero.c
--- linux-2.4.30/drivers/usb/gadget/zero.c	2005-01-19 15:10:07.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/usb/gadget/zero.c	2005-05-12 18:01:29.000000000 +0200
@@ -201,8 +201,13 @@
  * Instead:  allocate your own, using normal USB-IF procedures.
  */
 #ifndef	CONFIG_USB_ZERO_HNPTEST
+#ifdef CONFIG_USB_GADGET_AMD5536UDC
+#define DRIVER_VENDOR_NUM	0x0438		/* AMD */
+#define DRIVER_PRODUCT_NUM	0xdc00		/* Linux-USB "Gadget Zero" */
+#else
 #define DRIVER_VENDOR_NUM	0x0525		/* NetChip */
 #define DRIVER_PRODUCT_NUM	0xa4a0		/* Linux-USB "Gadget Zero" */
+#endif
 #else
 #define DRIVER_VENDOR_NUM	0x1a0a		/* OTG test device IDs */
 #define DRIVER_PRODUCT_NUM	0xbadd
@@ -1198,6 +1203,9 @@
 		device_desc.bcdDevice = __constant_cpu_to_le16 (0x0210);
 	} else if (gadget_is_pxa27x(gadget)) {
 		device_desc.bcdDevice = __constant_cpu_to_le16 (0x0211);
+	} else if (gadget_is_amd5536udc(gadget)) {
+		device_desc.bcdDevice = __constant_cpu_to_le16 (0x0212);
+                loopdefault = 1;
 	} else {
 		/* gadget zero is so simple (for now, no altsettings) that
 		 * it SHOULD NOT have problems with bulk-capable hardware.
@@ -1227,6 +1235,7 @@
 		goto enomem;
 	dev->req->buf = usb_ep_alloc_buffer (gadget->ep0, USB_BUFSIZ,
 				&dev->req->dma, GFP_KERNEL);
+        dev->req->length = USB_BUFSIZ;
 	if (!dev->req->buf)
 		goto enomem;
 
diff -Nur linux-2.4.30/drivers/usb/hcd.c linux-2.4.30-linux-mips.org/drivers/usb/hcd.c
--- linux-2.4.30/drivers/usb/hcd.c	2004-04-14 15:05:32.000000000 +0200
+++ linux-2.4.30-linux-mips.org/drivers/usb/hcd.c	2005-05-12 18:01:29.000000000 +0200
@@ -1505,3 +1505,166 @@
 	urb->complete (urb);
 }
 EXPORT_SYMBOL (usb_hcd_giveback_urb);
+
+#ifdef CONFIG_USB_NON_PCI_EHCI
+
+/*-------------------------------------------------------------------------*/
+
+/**
+ * usb_ehci_nonpci_remove/probe --
+ *
+ *
+ */
+
+// bogus pci_dev
+static struct pci_dev bogus_pcidev;
+static struct usb_hcd *nonpci_hcd;
+
+void usb_ehci_nonpci_remove(int base, int len)
+{
+	struct usb_device	*hub;
+	struct usb_hcd		*hcd;
+	struct pci_dev 		*dev;
+
+
+	dev = &bogus_pcidev;
+	hcd = nonpci_hcd;
+	if (!hcd)
+		return;
+	printk (KERN_INFO "%s %s: remove state %x\n",
+		hcd->description,  dev->slot_name, hcd->state);
+
+	if (in_interrupt ()) BUG ();
+
+	hub = hcd->bus->root_hub;
+	hcd->state = USB_STATE_QUIESCING;
+
+	dbg ("%s: roothub graceful disconnect", hcd->bus->bus_name);
+	usb_disconnect (&hub);
+	// usb_disconnect (&hcd->bus->root_hub);
+
+	hcd->driver->stop (hcd);
+	hcd->state = USB_STATE_HALT;
+
+	free_irq (hcd->irq, hcd);
+	iounmap (hcd->regs);
+	release_mem_region (base,len );
+
+	down (&hcd_list_lock);
+	list_del (&hcd->hcd_list);
+	up (&hcd_list_lock);
+
+	usb_deregister_bus (hcd->bus);
+	usb_free_bus (hcd->bus);
+	hcd->bus = NULL;
+
+	hcd->driver->hcd_free (hcd);
+}
+EXPORT_SYMBOL (usb_ehci_nonpci_remove);
+
+
+int usb_ehci_nonpci_probe (int base, int len, int irq,
+							const struct hc_driver *nonpci_ehci_driver)
+{
+	void *mem_base;
+	struct usb_bus		*bus;
+	struct usb_hcd		*hcd;
+	struct pci_dev 		*dev;
+	int					retval;
+	struct hc_driver	*driver = (struct hc_driver	*) nonpci_ehci_driver;
+
+	/*
+	* Fill in the bogus pci_dev. Only those members actually
+	* dereferenced in this driver are initialized.
+	*/
+	memset(&bogus_pcidev, 0, sizeof(struct pci_dev));
+	strcpy(bogus_pcidev.name, "non-PCI EHCI");
+	strcpy(bogus_pcidev.slot_name, "builtin.EHC");
+	bogus_pcidev.resource[0].name = "EHCI Operational Registers";
+	bogus_pcidev.resource[0].start = base;
+	bogus_pcidev.resource[0].end = base + len - 1;
+	bogus_pcidev.resource[0].flags = 0;
+	bogus_pcidev.irq = irq;
+	dev = &bogus_pcidev;
+
+	if (!base || !len || (irq < 0))
+		return -ENODEV;
+
+	if (!request_mem_region (base, len, "usb-ehci")) {
+		dbg ("controller already in use");
+		return -EBUSY;
+	}
+
+	mem_base = ioremap_nocache (base, len);
+	if (!mem_base) {
+		err("Error mapping EHCI memory");
+		retval = -EFAULT;
+clean_1:
+		release_mem_region (base, len);
+		err ("init %s fail, %d", dev->slot_name, retval);
+		return retval;
+	}
+
+
+	hcd = driver->hcd_alloc ();
+	if (hcd == NULL){
+		retval = -ENOMEM;
+clean_2:
+		iounmap ((void*)base);
+		dbg ("hcd alloc fail");
+		goto clean_1;
+	}
+
+	pci_set_drvdata(dev, hcd);
+	hcd->driver = driver;
+	hcd->description = driver->description;
+	hcd->pdev = dev;
+	printk (KERN_INFO "%s %s: %s\n",
+			hcd->description,  dev->slot_name, dev->name);
+
+	if (request_irq (dev->irq, hcd_irq, SA_SHIRQ, hcd->description, hcd)
+			!= 0) {
+		err ("request interrupt %d failed", dev->irq);
+		retval = -EBUSY;
+clean_3:
+		driver->hcd_free (hcd);
+		goto clean_2;
+	}
+	hcd->irq = dev->irq;
+	hcd->regs = (void*)mem_base;
+	hcd->region = 0;
+	printk (KERN_INFO "%s %s: irq %d, io base %p\n",
+		hcd->description,  dev->slot_name, dev->irq, (void*)mem_base);
+
+// FIXME simpler: make "bus" be that data, not pointer to it.
+// (fixed in 2.5)
+	bus = usb_alloc_bus (&hcd_operations);
+	if (bus == NULL) {
+		dbg ("usb_alloc_bus fail");
+		retval = -ENOMEM;
+		free_irq (dev->irq, hcd);
+		goto clean_3;
+	}
+	hcd->bus = bus;
+	bus->bus_name = dev->slot_name;
+	hcd->product_desc = dev->name;
+	bus->hcpriv = (void *) hcd;
+
+	INIT_LIST_HEAD (&hcd->dev_list);
+	INIT_LIST_HEAD (&hcd->hcd_list);
+
+	down (&hcd_list_lock);
+	list_add (&hcd->hcd_list, &hcd_list);
+	up (&hcd_list_lock);
+
+	usb_register_bus (bus);
+
+	if ((retval = driver->start (hcd)) < 0)
+		usb_ehci_nonpci_remove(base,len);
+
+	nonpci_hcd = hcd;
+	return retval;
+}
+EXPORT_SYMBOL (usb_ehci_nonpci_probe);
+
+#endif
diff -Nur linux-2.4.30/drivers/usb/hcd.h linux-2.4.30-linux-mips.org/drivers/usb/hcd.h
--- linux-2.4.30/drivers/usb/hcd.h	2003-06-13 16:51:36.000000000 +0200
+++ linux-2.4.30-linux-mips.org/drivers/usb/hcd.h	2005-05-12 18:01:29.000000000 +0200
@@ -169,6 +169,12 @@
 
 #endif /* CONFIG_PCI */
 
+#ifdef CONFIG_USB_NON_PCI_EHCI
+extern int usb_ehci_nonpci_probe (int base, int len, int irq,
+			const struct hc_driver *nonpci_ehci_driver);
+extern void usb_ehci_nonpci_remove (int base, int len);
+#endif
+
 /*-------------------------------------------------------------------------*/
 
 /*
diff -Nur linux-2.4.30/drivers/usb/host/Config.in linux-2.4.30-linux-mips.org/drivers/usb/host/Config.in
--- linux-2.4.30/drivers/usb/host/Config.in	2003-11-28 19:26:20.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/usb/host/Config.in	2005-05-12 18:01:29.000000000 +0200
@@ -3,6 +3,7 @@
 #
 comment 'USB Host Controller Drivers'
 dep_tristate '  EHCI HCD (USB 2.0) support (EXPERIMENTAL)' CONFIG_USB_EHCI_HCD $CONFIG_USB $CONFIG_EXPERIMENTAL
+dep_tristate '    Non-PCI EHCI support' CONFIG_USB_NON_PCI_EHCI $CONFIG_USB_EHCI_HCD
 if [ "$CONFIG_USB_UHCI_ALT" != "y" ]; then
    dep_tristate '  UHCI (Intel PIIX4, VIA, ...) support' CONFIG_USB_UHCI $CONFIG_USB
 fi
@@ -17,3 +18,4 @@
    dep_tristate '  SL811HS Alternate (x86, StrongARM, isosynchronous mode)' CONFIG_USB_SL811HS_ALT $CONFIG_USB $CONFIG_EXPERIMENTAL
    dep_tristate '  SL811HS (x86, StrongARM) support, old driver' CONFIG_USB_SL811HS $CONFIG_USB $CONFIG_EXPERIMENTAL
 fi
+dep_tristate '    Non-PCI OHCI support' CONFIG_USB_NON_PCI_OHCI $CONFIG_USB_OHCI
diff -Nur linux-2.4.30/drivers/usb/host/ehci-hcd.c linux-2.4.30-linux-mips.org/drivers/usb/host/ehci-hcd.c
--- linux-2.4.30/drivers/usb/host/ehci-hcd.c	2004-11-17 12:54:21.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/usb/host/ehci-hcd.c	2005-05-12 18:01:29.000000000 +0200
@@ -350,8 +350,11 @@
 	temp = HCC_EXT_CAPS (hcc_params);
 	while (temp) {
 		u32		cap;
-
+#ifndef CONFIG_USB_NON_PCI_EHCI
 		pci_read_config_dword (ehci->hcd.pdev, temp, &cap);
+#else
+		cap = 2;
+#endif
 		ehci_dbg (ehci, "capability %04x at %02x\n", cap, temp);
 		switch (cap & 0xff) {
 		case 1:			/* BIOS/SMM/... handoff */
@@ -436,8 +439,10 @@
 			ehci_info (ehci, "enabled 64bit PCI DMA\n");
 	}
 
+#ifndef CONFIG_USB_NON_PCI_EHCI
 	/* help hc dma work well with cachelines */
 	pci_set_mwi (ehci->hcd.pdev);
+#endif
 
 	/* clear interrupt enables, set irq latency */
 	temp = readl (&ehci->regs->command) & 0x0fff;
@@ -491,7 +496,11 @@
 	readl (&ehci->regs->command);	/* unblock posted write */
 
         /* PCI Serial Bus Release Number is at 0x60 offset */
+#ifndef CONFIG_USB_NON_PCI_EHCI
 	pci_read_config_byte (hcd->pdev, 0x60, &tempbyte);
+#else
+	tempbyte=0x20;
+#endif
 	temp = HC_VERSION(readl (&ehci->caps->hc_capbase));
 	ehci_info (ehci,
 		"USB %x.%x enabled, EHCI %x.%02x, driver %s\n",
@@ -1013,8 +1022,9 @@
 	.hub_control =		ehci_hub_control,
 };
 
-/*-------------------------------------------------------------------------*/
+#ifndef CONFIG_USB_NON_PCI_EHCI
 
+/*-------------------------------------------------------------------------*/
 /* EHCI spec says PCI is required. */
 
 /* PCI driver selection metadata; PCI hotplugging uses this */
@@ -1036,6 +1046,7 @@
 };
 MODULE_DEVICE_TABLE (pci, pci_ids);
 
+
 /* pci driver glue; this is a "new style" PCI driver module */
 static struct pci_driver ehci_pci_driver = {
 	.name =		(char *) hcd_name,
@@ -1050,6 +1061,47 @@
 #endif
 };
 
+#else /* CONFIG_USB_NON_PCI_EHCI */
+
+// Boot options
+static int ehci_base=0, ehci_len=0;
+static int ehci_IRQ=-1;
+
+MODULE_PARM(ehci_base, "i");
+MODULE_PARM(ehci_len, "i");
+MODULE_PARM(ehci_IRQ, "i");
+MODULE_PARM_DESC(ehci_base, "IO Base address of EHCI Oper. registers");
+MODULE_PARM_DESC(ehci_len, "IO length of EHCI Oper. registers");
+MODULE_PARM_DESC(ehci_IRQ, "IRQ for EHCI interrupts");
+
+#ifndef MODULE
+
+static int __init
+ehci_setup (char* options)
+{
+	char* this_opt;
+
+	if (!options || !*options)
+		return 0;
+
+	for(this_opt=strtok(options,",");this_opt;this_opt=strtok(NULL,",")) {
+		if (!strncmp(this_opt, "base:", 5)) {
+			ehci_base = simple_strtoul(this_opt+5, NULL, 0);
+		} else if (!strncmp(this_opt, "len:", 4)) {
+			ehci_len = simple_strtoul(this_opt+4, NULL, 0);
+		} else if (!strncmp(this_opt, "irq:", 4)) {
+			ehci_IRQ = simple_strtoul(this_opt+4, NULL, 0);
+		}
+	}
+	return 0;
+}
+
+__setup("usb_ehci=", ehci_setup);
+
+#endif  /* !MODULE */
+
+#endif /* CONFIG_USB_NON_PCI_EHCI */
+
 #define DRIVER_INFO DRIVER_VERSION " " DRIVER_DESC
 
 MODULE_DESCRIPTION (DRIVER_INFO);
@@ -1063,12 +1115,20 @@
 		sizeof (struct ehci_qh), sizeof (struct ehci_qtd),
 		sizeof (struct ehci_itd), sizeof (struct ehci_sitd));
 
+#ifndef CONFIG_USB_NON_PCI_EHCI
 	return pci_module_init (&ehci_pci_driver);
+#else
+	return usb_ehci_nonpci_probe(ehci_base,ehci_len,ehci_IRQ,&ehci_driver);
+#endif
 }
 module_init (init);
 
 static void __exit cleanup (void) 
 {	
+#ifndef CONFIG_USB_NON_PCI_EHCI
 	pci_unregister_driver (&ehci_pci_driver);
+#else
+	usb_ehci_nonpci_remove(ehci_base,ehci_len);
+#endif
 }
 module_exit (cleanup);
diff -Nur linux-2.4.30/drivers/usb/host/usb-ohci.c linux-2.4.30-linux-mips.org/drivers/usb/host/usb-ohci.c
--- linux-2.4.30/drivers/usb/host/usb-ohci.c	2005-01-19 15:10:07.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/usb/host/usb-ohci.c	2005-05-12 18:01:29.000000000 +0200
@@ -2564,6 +2564,7 @@
 		hc_release_ohci (ohci);
 		return ret;
 	}
+#ifndef CONFIG_USB_NON_PCI_OHCI
 	ohci->flags = id->driver_data;
 	
 	/* Check for NSC87560. We have to look at the bridge (fn1) to identify
@@ -2582,6 +2583,7 @@
 		printk (KERN_INFO __FILE__ ": Using NSC SuperIO setup\n");
 	if (ohci->flags & OHCI_QUIRK_AMD756)
 		printk (KERN_INFO __FILE__ ": AMD756 erratum 4 workaround\n");
+#endif
 
 	if (hc_reset (ohci) < 0) {
 		hc_release_ohci (ohci);
@@ -2627,8 +2629,10 @@
 	int temp;
 	int i;
 
+#ifndef CONFIG_USB_NON_PCI_OHCI
 	if (ohci->pci_latency)
 		pci_write_config_byte (ohci->ohci_dev, PCI_LATENCY_TIMER, ohci->pci_latency);
+#endif
 
 	ohci->disabled = 1;
 	ohci->sleeping = 0;
@@ -2658,6 +2662,7 @@
 
 /*-------------------------------------------------------------------------*/
 
+#ifndef CONFIG_USB_NON_PCI_OHCI
 /* configured so that an OHCI device is always provided */
 /* always called with process context; sleeping is OK */
 
@@ -2705,6 +2710,88 @@
 	}
 	return status;
 } 
+#else  /* CONFIG_USB_NON_PCI_OHCI */
+
+// Boot options
+static int ohci_base=0, ohci_len=0;
+static int ohci_irq=-1;
+
+MODULE_PARM(ohci_base, "i");
+MODULE_PARM(ohci_len, "i");
+MODULE_PARM(ohci_irq, "i");
+MODULE_PARM_DESC(ohci_base, "IO Base address of OHCI Oper. registers");
+MODULE_PARM_DESC(ohci_len, "IO length of OHCI Oper. registers");
+MODULE_PARM_DESC(ohci_irq, "IRQ for OHCI interrupts");
+
+// bogus pci_dev
+static struct pci_dev bogus_pcidev;
+
+static struct pci_driver ohci_pci_driver = {
+	name:		"usb-ohci",
+};
+
+static int __devinit
+ohci_non_pci_init (void)
+{
+	void *mem_base;
+
+	if (!ohci_base || !ohci_len || (ohci_irq < 0)) 
+		return -ENODEV;
+
+	if (!request_mem_region (ohci_base, ohci_len, ohci_pci_driver.name)) {
+		dbg ("controller already in use");
+		return -EBUSY;
+	}
+
+	mem_base = ioremap_nocache (ohci_base, ohci_len);
+	if (!mem_base) {
+		err("Error mapping OHCI memory");
+		return -EFAULT;
+	}
+
+	/*
+	* Fill in the bogus pci_dev. Only those members actually
+	* dereferenced in this driver are initialized.
+	*/
+	memset(&bogus_pcidev, 0, sizeof(struct pci_dev));
+	strcpy(bogus_pcidev.name, "non-PCI OHCI");
+	strcpy(bogus_pcidev.slot_name, "builtin.OHC");
+	bogus_pcidev.resource[0].name = "OHCI Operational Registers";
+	bogus_pcidev.resource[0].start = ohci_base;
+	bogus_pcidev.resource[0].end = ohci_base + ohci_len - 1;
+	bogus_pcidev.resource[0].flags = 0;
+	bogus_pcidev.irq = ohci_irq;
+
+	return hc_found_ohci (&bogus_pcidev, bogus_pcidev.irq, mem_base, NULL);
+} 
+
+#ifndef MODULE
+
+static int __init
+ohci_setup (char* options)
+{
+	char* this_opt;
+
+	if (!options || !*options)
+		return 0;
+
+	for(this_opt=strtok(options,",");this_opt;this_opt=strtok(NULL,",")) {
+		if (!strncmp(this_opt, "base:", 5)) { 
+			ohci_base = simple_strtoul(this_opt+5, NULL, 0);
+		} else if (!strncmp(this_opt, "len:", 4)) { 
+			ohci_len = simple_strtoul(this_opt+4, NULL, 0);
+		} else if (!strncmp(this_opt, "irq:", 4)) { 
+			ohci_irq = simple_strtoul(this_opt+4, NULL, 0);
+		}
+	}
+	return 0;
+}
+
+__setup("usb_ohci=", ohci_setup);
+
+#endif  /* !MODULE */
+
+#endif  /* CONFIG_USB_NON_PCI_OHCI */
 
 /*-------------------------------------------------------------------------*/
 
@@ -2740,11 +2827,16 @@
 
 	hc_release_ohci (ohci);
 
+#ifndef CONFIG_USB_NON_PCI_OHCI
 	release_mem_region (pci_resource_start (dev, 0), pci_resource_len (dev, 0));
 	pci_disable_device (dev);
+#else
+	release_mem_region (ohci_base, ohci_len);
+#endif
 }
 
 
+#ifndef CONFIG_USB_NON_PCI_OHCI
 #ifdef	CONFIG_PM
 
 /*-------------------------------------------------------------------------*/
@@ -2983,20 +3075,29 @@
 	resume:		ohci_pci_resume,
 #endif	/* PM */
 };
+#endif /* CONFIG_USB_NON_PCI_OHCI */
 
  
 /*-------------------------------------------------------------------------*/
 
 static int __init ohci_hcd_init (void) 
 {
+#ifndef CONFIG_USB_NON_PCI_OHCI
 	return pci_module_init (&ohci_pci_driver);
+#else
+	return ohci_non_pci_init();
+#endif
 }
 
 /*-------------------------------------------------------------------------*/
 
 static void __exit ohci_hcd_cleanup (void) 
 {	
+#ifndef CONFIG_USB_NON_PCI_OHCI
 	pci_unregister_driver (&ohci_pci_driver);
+#else
+	ohci_pci_remove(&bogus_pcidev);
+#endif
 }
 
 module_init (ohci_hcd_init);
